summaryrefslogtreecommitdiff
path: root/install.sh
diff options
context:
space:
mode:
authorColin Pitrat <colin.pitrat@gmail.com>2019-03-20 11:18:39 +0000
committerColin Pitrat <colin.pitrat@gmail.com>2019-03-20 11:18:39 +0000
commitfd4eda8bda87fb5efe4c0e99a042d095a40c6b90 (patch)
treed5d51f4413744e845d945dd1b82253d1554dc35d /install.sh
parentbf8d927ab279be5626bc80feeb0d465fb410b9a5 (diff)
Verify that rust version is recent enough to install rustlings.
I would have liked to write some tests for the vercomp function I introduce, but there doesn't seem to be any CI setup yet?
Diffstat (limited to 'install.sh')
-rwxr-xr-xinstall.sh52
1 files changed, 52 insertions, 0 deletions
diff --git a/install.sh b/install.sh
index b286025..05cc635 100755
--- a/install.sh
+++ b/install.sh
@@ -30,6 +30,58 @@ else
echo "SUCCESS: Cargo is installed"
fi
+# Function that compares two versions strings v1 and v2 given in arguments (e.g 1.31 and 1.33.0).
+# Returns 1 if v1 > v2, 0 if v1 == v2, 2 if v1 < v2.
+function vercomp() {
+ if [[ $1 == $2 ]]
+ then
+ return 0
+ fi
+ v1=( ${1//./ } )
+ v2=( ${2//./ } )
+ len1=${#v1[@]}
+ len2=${#v2[@]}
+ max_len=$len1
+ if [[ $max_len -lt $len2 ]]
+ then
+ max_len=$len2
+ fi
+ for i in `seq 0 $max_len`
+ do
+ # Fill empty fields with zeros in v1
+ if [ -z "${v1[$i]}" ]
+ then
+ v1[$i]=0
+ fi
+ if [ -z "${v2[$i]}" ]
+ then
+ v2[$i]=0
+ fi
+ # And in v2
+ if [ ${v1[$i]} -gt ${v2[$i]} ]
+ then
+ return 1
+ fi
+ if [ ${v1[$i]} -lt ${v2[$i]} ]
+ then
+ return 2
+ fi
+ done
+ return 0
+}
+
+RustVersion=$(rustc --version | cut -d " " -f 2)
+MinRustVersion=1.31
+vercomp $RustVersion $MinRustVersion
+if [ $? -eq 2 ]
+then
+ echo "WARNING: Rust version is too old: $RustVersion - needs at least $MinRustVersion"
+ echo "Please update Rust with 'rustup update'"
+ exit 1
+else
+ echo "SUCCESS: Rust is up to date"
+fi
+
Path=${1:-rustlings/}
echo "Cloning Rustlings at $Path..."
git clone -q https://github.com/rust-lang/rustlings $Path